(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (factory((global.lilStore = {})));
}(this, (function (exports) { 'use strict';

  function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

  function createStore(reducer) {
    var store = void 0;
    var listener = [];

    return {
      getState: function getState() {
        return store;
      },
      commit: function commit(action, payload) {
        store = reducer(store, action, payload);
        listener.forEach(function (cur) {
          return cur(store, action);
        });
      },
      subscribe: function subscribe(cb) {
        if (typeof cb === 'function') {
          listener = [].concat(_toConsumableArray(listener), [cb]);
        } else {
          throw new Error('"subscribe()" must be passed in a function!');
        }
      }
    };
  }

  exports.createStore = createStore;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
